; 
    include \masm32\include\masm32rt.inc
; 
    .data
      nrand_seed  dd 1
      rand32_seed dd 1
      fn_nrandom  db "_nrandom.bin",0
      fn_nrand    db "_nrand.bin",0
      fn_rand32   db "_rand32.bin",0
    .code
; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4
nrand proc base:DWORD
    mov ecx, nrand_seed
    mov edx, ecx
    sar edx, 16
    imul edx, edx, 16807
    movzx eax, cx
    imul eax, eax, 16807
    mov ecx, edx
    shr edx, 15
    and ecx, 32767
    sal ecx, 16
    add eax, ecx
    add eax, edx
    js  L2
  L1:
    xor edx, edx
    mov nrand_seed, eax
    div dword ptr[esp+4]
    mov eax, edx
    ret 4
  L2:
    sub eax, 2147483647
    jmp L1
nrand endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4
rand32 proc base:DWORD

    mov eax, rand32_seed
    mov ecx, 16807              ; a = 7^5
    mul ecx                     ; edx:eax == a*seed == D:A
    mov ecx, 7fffffffh          ; ecx = m

;**** Park-Miller mod
;   div     ecx
;   mov     eax, edx            ; (a*seed) % 7fffffff

;**** Carta alternative mod

    add edx, edx                ; edx = 2*D
    cmp eax, ecx                ; eax = A
    jna @F
    sub eax, ecx                ; if A>m, A = A - m
  @@:
    add eax, edx                ; eax = A + 2*D
    jns @F
    sub eax, ecx                ; If (A + 2*D)>m
;****
  @@:
    mov rand32_seed, eax        ; save new seed

    xor edx, edx
    div DWORD PTR [esp+4]       ; base
    mov eax, edx
    ret 4

rand32  endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 
start:
; 
    mov edi, alloc(1000000)

     xor ebx, ebx
    .WHILE ebx < 1000000
      invoke nrandom, 256
      mov [edi+ebx], al
      inc ebx
    .ENDW

    invoke write_disk_file,ADDR fn_nrandom,edi,1000000
    
    xor ebx, ebx
    .WHILE ebx < 1000000
      invoke nrand, 256
      mov [edi+ebx], al
      inc ebx    
    .ENDW

    invoke write_disk_file,ADDR fn_nrand,edi,1000000

    xor ebx, ebx
    .WHILE ebx < 1000000
      invoke rand32, 256
      mov [edi+ebx], al
      inc ebx    
    .ENDW

    invoke write_disk_file,ADDR fn_rand32,edi,1000000

    free edi
    inkey "Press any key to exit..."
    exit
; 
end start
 