; 
    include \masm32\include\masm32rt.inc
    .686
    include counter2.asm
; 
    .data
      nrand_seed  dd 1
      rand32_seed dd 1
      seq         dd 10 dup(0)
      include rns.asm
    .code
; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4
nrand proc base:DWORD
    mov ecx, nrand_seed
    mov edx, ecx
    sar edx, 16
    imul edx, edx, 16807
    movzx eax, cx
    imul eax, eax, 16807
    mov ecx, edx
    shr edx, 15
    and ecx, 32767
    sal ecx, 16
    add eax, ecx
    add eax, edx
    js  L2
  L1:
    xor edx, edx
    mov nrand_seed, eax
    div DWORD PTR [esp+4]
    mov eax, edx
    ret 4
  L2:
    sub eax, 2147483647
    jmp L1
nrand endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4
rand32 proc base:DWORD

    mov eax, rand32_seed
    mov ecx, 16807              ; a = 7^5
    mul ecx                     ; edx:eax == a*seed == D:A
    mov ecx, 7fffffffh          ; ecx = m

;**** Park-Miller mod
;   div     ecx
;   mov     eax, edx            ; (a*seed) % 7fffffff

;**** Carta alternative mod

    add edx, edx                ; edx = 2*D
    cmp eax, ecx                ; eax = A
    jna @F
    sub eax, ecx                ; if A>m, A = A - m
  @@:
    add eax, edx                ; eax = A + 2*D
    jns @F
    sub eax, ecx                ; If (A + 2*D)>m
;****
  @@:
    mov rand32_seed, eax        ; save new seed

    xor edx, edx
    div DWORD PTR [esp+4]       ; base
    mov eax, edx
    ret 4

rand32  endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

nrandom_period proc
    xor ebx, ebx
    .WHILE ebx < 10
      invoke nrandom,0ffffffffh
      mov [seq+ebx*4], eax
      inc ebx
    .ENDW
    xor ebx, ebx
    .WHILE ebx < 0ffffffffh
      invoke nrandom,0ffffffffh
      .IF eax == seq
        mov esi, eax
        print "duplication @ "
        print ustr$(ebx),13,10
        print ustr$(esi),9
        print ustr$(esi),13,10
        mov esi, 1
        .WHILE esi < 10
          print ustr$([seq+esi*4]),9
          invoke nrandom,0ffffffffh
          print ustr$(eax),13,10
          inc esi
        .ENDW
        .BREAK
      .ENDIF
      inc ebx
    .ENDW
    ret
nrandom_period endp

; 

nrand_period proc
    xor ebx, ebx
    .WHILE ebx < 10
      invoke nrand,0ffffffffh
      mov [seq+ebx*4], eax
      inc ebx
    .ENDW
    xor ebx, ebx
    .WHILE ebx < 0ffffffffh
      invoke nrand,0ffffffffh
      .IF eax == seq
        mov esi, eax
        print "duplication @ "
        print ustr$(ebx),13,10
        print ustr$(esi),9
        print ustr$(esi),13,10
        mov esi, 1
        .WHILE esi < 10
          print ustr$([seq+esi*4]),9
          invoke nrand,0ffffffffh
          print ustr$(eax),13,10
          inc esi
        .ENDW
        .BREAK
      .ENDIF
      inc ebx
    .ENDW
    ret
nrand_period endp

; 

rand32_period proc
    xor ebx, ebx
    .WHILE ebx < 10
      invoke rand32,0ffffffffh
      mov [seq+ebx*4], eax
      inc ebx
    .ENDW
    xor ebx, ebx
    .WHILE ebx < 0ffffffffh
      invoke rand32,0ffffffffh
      .IF eax == seq
        mov esi, eax
        print "duplication @ "
        print ustr$(ebx),13,10
        print ustr$(esi),9
        print ustr$(esi),13,10
        mov esi, 1
        .WHILE esi < 10
          print ustr$([seq+esi*4]),9
          invoke rand32,0ffffffffh
          print ustr$(eax),13,10
          inc esi
        .ENDW
        .BREAK
      .ENDIF
      inc ebx
    .ENDW
    ret
rand32_period endp

; 
start:
; 

    ; --------------------------------------------------
    ; Verify that first 1000 values from the generated
    ; sequence match the sequence from a known-good
    ; implementation.
    ; --------------------------------------------------

    print "Verifying nrand sequence..."
    xor ebx, ebx
    .WHILE ebx < 1000
      invoke nrand, 256
      .IF [rns+ebx*4] != eax
        print "mismatch @ "
        print ustr$(ebx),13,10
        .BREAK
      .ENDIF
      inc ebx
    .ENDW
    .IF ebx == 1000
      print "OK",13,10,13,10
    .ENDIF

    print "Verifying rand32 sequence..."
    xor ebx, ebx
    .WHILE ebx < 1000
      invoke rand32, 256
      .IF [rns+ebx*4] != eax
        print "mismatch @ "
        print ustr$(ebx),13,10
        .BREAK
      .ENDIF
      inc ebx
    .ENDW
    .IF ebx == 1000
      print "OK",13,10,13,10
    .ENDIF

    invoke nseed,1
    mov nrand_seed, 1
    mov rand32_seed, 1
    
    invoke Sleep, 2000

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke nrandom, 100
    ctr_end
    print ustr$(eax)," cycles, nrandom",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke nrand, 100
    ctr_end
    print ustr$(eax)," cycles, nrand",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke rand32, 100
    ctr_end
    print ustr$(eax)," cycles, rand32",13,10,13,10

    inkey "Press any key to continue...",13,10

    ; --------------------------
    ; Test the bad seed values.
    ; --------------------------

    invoke nseed, 0
    mov nrand_seed, 0
    mov rand32_seed, 0
    
    print "Testing nrandom with seed = 0..."
    call nrandom_period
    inkey "Press any key to continue...",13,10

    print "Testing nrand with seed = 0..."
    call nrand_period
    inkey "Press any key to continue...",13,10

    print "Testing rand32 with seed = 0..."
    call rand32_period
    inkey "Press any key to continue...",13,10

    invoke nseed, 2147483647
    mov nrand_seed, 2147483647
    mov rand32_seed, 2147483647    

    print "Testing nrandom with seed = 2147483647..."
    call nrandom_period
    inkey "Press any key to continue...",13,10

    print "Testing nrand with seed = 2147483647..."
    call nrand_period
    inkey "Press any key to continue...",13,10

    print "Testing rand32 with seed = 2147483647..."
    call rand32_period
    inkey "Press any key to continue...",13,10

    ; ---------------------------------------------------
    ; Determine the periods for the first and last good
    ; seeds. This will take a while on a slow system.
    ; ---------------------------------------------------

    invoke nseed, 1
    mov nrand_seed, 1
    mov rand32_seed, 1

    print "Determining nrandom period with seed = 1..."
    call nrandom_period
    inkey "Press any key to continue...",13,10

    print "Determining nrand period with seed = 1..."
    call nrand_period
    inkey "Press any key to continue...",13,10

    print "Determining rand32 period with seed = 1..."
    call rand32_period
    inkey "Press any key to continue...",13,10

    invoke nseed, 2147483646
    mov nrand_seed, 2147483646
    mov rand32_seed, 2147483646

    print "Determining nrandom period with seed = 2147483646..."
    call nrandom_period
    inkey "Press any key to continue...",13,10

    print "Determining nrand period with seed = 2147483646..."
    call nrand_period
    inkey "Press any key to continue...",13,10

    print "Determining rand32 period with seed = 2147483646..."
    call rand32_period
    inkey "Press any key to continue...",13,10

    inkey "Press any key to exit..."
    exit
; 
end start
